<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="logId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          v-model:selection="selection"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'money'">
              <div class="ele-text-danger" @click="openEdit(record)"
                >￥{{ record.money }}</div
              >
            </template>
            <template v-if="column.key === 'payStatus'">
              <a-tag v-if="record.payStatus === 20" color="green">已支付</a-tag>
              <a-tag
                v-if="record.payStatus === 10"
                color="red"
                @click="onPay(record)"
                >待支付</a-tag
              >
            </template>
            <template v-if="column.key === 'isSettled'">
              <a-tag v-if="record.isSettled === 1" color="green">已结算</a-tag>
              <a-tag v-if="record.isSettled === 0" color="red">待结算</a-tag>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 1" color="success">已处理</a-tag>
              <a-tag
                v-if="record.status === 0"
                color="red"
                @click.stop="onStatus(record)"
                >待处理</a-tag
              >
            </template>
            <template v-if="column.key === 'nickname'">
              <a-tooltip :title="`${record.nickname} (${record.userId})`">
                <a-avatar :src="record.userAvatar" size="small" />
                <span style="padding-left: 3px">{{ record.nickname }}</span>
              </a-tooltip>
            </template>
            <template v-if="column.key === 'idCard'">
              <div>{{ record.realName }} {{ record.phone }}</div>
              <div>{{ record.idCard }}</div>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">房源信息</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>
      <!-- 编辑弹窗 -->
      <ReservationEdit
        v-model:visible="showEdit"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import {
    pageHouseReservation,
    removeHouseReservation,
    removeBatchHouseReservation,
    updateHouseReservation
  } from '@/api/house/houseReservation';
  import ReservationEdit from './components/reservation-edit.vue';
  import { timeAgo } from 'ele-admin-pro';
  import type {
    HouseReservation,
    HouseReservationParam
  } from '@/api/house/houseReservation/model';
  import { useUserStore } from '@/store/modules/user';

  const userStore = useUserStore();
  // 当前用户信息
  const loginUser = computed(() => userStore.info ?? {});

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<HouseReservation[]>([]);
  // 当前编辑数据
  const current = ref<HouseReservation | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageHouseReservation({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '订单号',
      dataIndex: 'logId'
    },
    // {
    //   title: '房源信息',
    //   dataIndex: 'houseId',
    //   key: 'houseId'
    // },
    // {
    //   title: '付款金额',
    //   dataIndex: 'money',
    //   key: 'money',
    //   sorter: true
    // },
    {
      title: '客户信息',
      dataIndex: 'idCard',
      key: 'idCard'
    },
    {
      title: '看房日期',
      dataIndex: 'expirationTime'
    },
    {
      title: '备注信息',
      dataIndex: 'comments',
      key: 'comments'
    },
    {
      title: '处理状态',
      dataIndex: 'status',
      key: 'status'
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      sorter: true
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: HouseReservationParam) => {
    console.log(where);
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: HouseReservation) => {
    if (row?.payStatus == 10) {
      current.value = row ?? null;
      showEdit.value = true;
    }
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  const onPay = (item) => {
    Modal.confirm({
      title: '提示',
      content: '确认已收到款项并改变订单支付状态',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        item.payStatus = 20;
        item.comments = '人工确认收款结算方式';
        updateHouseReservation(item)
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  const onStatus = (item) => {
    Modal.confirm({
      title: '提示',
      content: '确定要改变该订单的状态吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        item.status = 1;
        updateHouseReservation(item)
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 删除单个 */
  const remove = (row: HouseReservation) => {
    const hide = message.loading('请求中..', 0);
    removeHouseReservation(row.logId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchHouseReservation(selection.value.map((d) => d.logId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: HouseReservation) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };

  query();
</script>

<script lang="ts">
  export default {
    name: 'Reservation'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
